properties([gitLabConnection('https://gitlab.com/')])

node('Macbuild') {
      try {
          stage('Checkout') {
            //checkoutRepo()
            checkout scm
          }
          gitlabCommitStatus("build") {
            stage('Build') {
           
               buildXcodeProject()
            }
         }
          stage ('Notify') {
            //notifyGithub("pass", "SUCCESS")
            updateGitlabCommitStatus name: 'build', state: 'success'

            notifySuccessful()
          }
        } catch(e) {
          //notifyGithub("fail", "FAILURE")
          notifyFailed()
      }
  }

def notifyGithub(message, state) {
  step([
  $class: "GitHubCommitStatusSetter",
  reposSource: [$class: "ManuallyEnteredRepositorySource", url: "https://github.com/kylelol/time-table.git"],
  contextSource: [$class: "ManuallyEnteredCommitContextSource", context: "ci/jenkins/build-status"],
  errorHandlers: [[$class: "ChangingBuildStatusErrorHandler", result: "UNSTABLE"]],
  statusResultSource: [ $class: "ConditionalStatusResultSource", results: [[$class: "AnyBuildResult", message: message, state: state]]]]);
}

def buildXcodeProject() {
  sh 'xcodebuild -scheme "TestJenkins" -configuration "Debug" build -destination "platform=iOS Simulator,name=iPhone 6,OS=10.3.1"'
}

def checkoutRepo() {
  checkout([
    $class: 'GitSCM',
    branches: [[name: 'master']],
    doGenerateSubmoduleConfigurations: false,
    extensions: [], submoduleCfg: [],
    userRemoteConfigs: [[
        name: 'gitlab',
        url: 'https://gitlab.com/kyle.kirkland/Test-jenkins.git'
    ]]
  ])
}

def notifyStarted() {
    slackSend (color: '#FFFF00', message: "STARTED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]' (${env.BUILD_URL})")
}

def notifySuccessful() {
    slackSend (color: '#00FF00', message: "SUCCESSFUL: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]' (${env.BUILD_URL})")
}

def notifyFailed() {
  slackSend (color: '#FF0000', message: "FAILED: Job '${env.JOB_NAME} [${env.BUILD_NUMBER}]' (${env.BUILD_URL})")
}
